diff -uwrN sourceold/scripts/jmgUtility.h source/scripts/jmgUtility.h
--- sourceold/scripts/jmgUtility.h	2017-11-23 09:14:58.449800000 +1000
+++ source/scripts/jmgUtility.h	2018-11-11 08:30:08.537600000 +1000
@@ -5968,3 +6075,743 @@
 class JMG_Utility_Damaged_Create_Object_When_Shield_Zero : public ScriptImpClass {
 	void Damaged(GameObject *obj,GameObject *damager,float damage);
 };
\ No newline at end of file
+
+/*!
+* \brief Spawns objects randomly in a circle using ray casts to find the ground around the location specified can have scripts attached to the spawned object with JMG_Utility_Basic_Spawner_Attach_Script
+* \Spawn_Preset - Preset to create (can be a twiddler).
+* \Spawn_Rate - Rate at which to spawn more objects (also used to respawn when an object is killed).
+* \Random_Spawn_Rate - Random amount to add or subtract from the spawn time.
+* \Spawn_At_A_Time - Number of instances of the spawned object can exist at once, for example in a traditional spawner only 1 can exist at a time.
+* \Min_Spawn_Radius - The min size of the radius to spawn in, non-zero makes a torus basically
+* \Max_Spawn_Radius - The max size of the radius to spawn in.
+* \Initial_Spawn_Height - Adds this much to the Z axis on object creation.
+* \Spawn_Limit - How many times can objects be spawned before being disabled, -1 means no limit.
+* \Spawn_Location - Location in which to spawn the objects, -1 -1 ? (Last value is the height of which to start casting the ray from, -1 makes it the current position)
+* \X_Multiplier - Multiply how the circle is shaped on the X coordinates, default is 1.0.
+* \Y_Multiplier - Multiply how the circle is shaped on the Y coordinates, default is 1.0.
+* \Collision_Check - Check if the spawn location is clear to create the object, 0 means it'll place even if blocked.
+* \Collision_Retry_Attempts - How many times will the script "bump" the object if the collision is blocked.
+* \Collision_Add_Height - Amount of height to add each time if blocked.
+* \Initial_Spawn - Setting the value to -1 will spawn the Spawn_At_A_Time on create, any 0 or above will make the objects slowly spawn in at the spawn rate.
+* \Script_ID - Set the id for this script, -1 uses default (only use this if you're going to need to manually add spawned objects to this spawner).
+* \Point_Must_Be_In_Pathfind - Requires the created point to be in the pathfind field, if its outside of the field the point will not be created.
+* \Manual_Facing - If true random facing will not be used, first it will attempt to use Face_Location and if that's all 0's Face_Direction
+* \Face_Location - If anything besides 0,0,0 all objects created will attempt to face the point
+* \Face_Direction - If Face_Location was 0,0,0 then Face_Direction will be used
+* \Ignore_Ray_Cast_Failure - If a ray fails to cast the script will stop by default (this usually means that it cast beyond the terrain) turn this setting on to continue casting
+* \Min_Distance_Between_Objects - If non-zero the script will place objects at least the specified distance away from other objects in the group
+* \Spawn_Group_ID - The spawn group id which these objects belong to, if -1 or 0 the distance will be checked against all spawn groups (-1 adds the objects to a group, 0 does not)
+* \ if the value is above 0 the objects will only be checked against other objects with the same value.
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Basic_Spawner_In_Radius : public ScriptImpClass {
+public:
+	struct SpawnObjectNode
+	{
+		int groupId;
+		ReferencerClass obj;
+		SpawnObjectNode(GameObject *obj,int spawnGroupId)
+		{
+			this->obj = obj;
+			this->groupId = spawnGroupId;
+		}
+	};
+	static SList<SpawnObjectNode> spawnObjectNodeList;
+private:
+	float minDistanceBetweenObjects;
+	int spawnGroupId;
+	int scriptId;
+	int spawnedObjects;
+	enum SpawnFailureTypes{SPAWN_BLOCKED, SUCCESS, LIMIT_REACHED, SPAWN_CODE_ERROR};
+	Vector3 spawnLocation;
+	int spawnAtATime;
+	int spawnLimit;
+	float minRadius;
+	float maxRadius;
+	float xMultiplier;
+	float yMultiplier;
+	float addHeight;
+	float rate;
+	float randomRate;
+	char preset[128];
+	int spawnCount;
+	bool collisionCheck;
+	int retryAttempts;
+	float initialSpawnHeight;
+	int changeSpawnCapCustom;
+	bool pointMustBeInPathfind;
+	bool manualFacing;
+	bool ignoreRayCastFailure;
+	Vector3 faceLocation;
+	float faceDirection;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	SpawnFailureTypes AttemptSpawn(GameObject *obj);
+	bool CheckIfObjectIsNearAnotherObject(Vector3 pos);
+	void SetFacing(GameObject *obj,float facing);
+};
+
+/*!
+* \brief Tells an object that it belongs to a group of the JMG_Utility_Basic_Spawner_In_Radius (normally attached by JMG_Utility_Basic_Spawner_In_Radius)
+* \ A case where manually using this would make sense would be in a drop cinematic, you might have to define on the vehicle object it belongs to the spawn controller.
+* \Controller_ID - ID of the object with JMG_Utility_Basic_Spawner_In_Radius attached.
+* \Script_ID - Manually or automatically set Script_ID on JMG_Utility_Basic_Spawner_In_Radius.
+* \Spawn_Group_ID - Manually or automatically set Spawn_Group_ID on JMG_Utility_Basic_Spawner_In_Radius.
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Basic_Spawner_In_Radius_Attached: public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Destroyed(GameObject *obj);
+	void AddSpawnedObjectToGroup(GameObject *spawned);
+};
+
+/*!
+* \brief Applies damage based on speed when a flying vehicle collides with terrain or another object
+* \Min_Collision_Speed - Min speed in M/S to detect collisions
+* \Max_Collision_Speed - Max speed a collision can happen and still survive (assuming full health)
+* \Collision_Sound - Sound to play when colliding
+* \Explosion_Preset - Explosion to create when the vehicle dies from a collision
+* \Subtract_Min_Speed - Use this to subtract the min speed from the actual, thus reducing damage done and increasing the amount of speed needed to die
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Flying_Vehicle_Crash_Apply_Damage : public ScriptImpClass {
+	bool subtractMinSpeed;
+	char explosionPreset[128];
+	char collisionSound[128];
+	bool allowCrash;
+	float minCollisionSpeed;
+	float maxCollisionSpeed;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Sends a custom when an enemy is seen, sends a custom again after no enemy in the criteria is visible
+* \Enemy_Preset_ID - Preset ID required to be seen to remove the script, if 0 any enemy will trigger the script
+* \ID - Id of the object to send the custom to, 0 sends to itself, -1 sends to the seen object
+* \Visible_Message - Custom to send when there is a target that is visible
+* \Visible_Param - Param to send when there is a target that is visible
+* \Not_Visible_Message - Custom sent when no preset is visible anymore
+* \Not_Visible_Param - Param sent when no preset is visible anymore
+* \Max_Lost_Sight_Time - This is the max amount of time an enmey can go without being seen before being lost, 
+* \  game scans at least once a second so I reccomend at least 2.5 seconds if not longer
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Enemy_Seen_Send_Custom : public ScriptImpClass {
+	int lastEnemyId;
+	int seenTime;
+	int enemyPresetId;
+	int id;
+	int visibleMessage;
+	int notVisibleMessage;
+	int visibleParam;
+	int notVisibleParam;
+	int maxNotSeenTime;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Enemy_Seen(GameObject *obj,GameObject *seen);
+};
+
+/*!
+* \brief Sends a custom on a custom if the specified script is attached
+* \Custom - Custom to count
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to add
+* \Script - script that must be attached to this object in order to send the custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_If_Script_Attached : public ScriptImpClass {
+	char script[128];
+	int recieveMessage;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom on a custom if the specified script is not attached
+* \Custom - Custom to count
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to add
+* \Script - script that must not be attached to this object in order to send the custom
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_If_Script_Not_Attached : public ScriptImpClass {
+	char script[128];
+	int recieveMessage;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Place this script on an object that exists the duration of the map, all it does is deletes the spawn group nodes if you use them on game end.
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Basic_Spawner_In_Radius_Controller: public ScriptImpClass {
+	void Destroyed(GameObject *obj);
+};
+
+/*!
+* \brief Enables or disables the attached vehicles engine on custom
+* \Custom - Custom to trigger on
+* \Enable - Whether to enable or disable the engine, -1 uses the param instead
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Set_Engine : public ScriptImpClass {
+	int custom;
+	int enable;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom when the count of presets on the map matches the player count
+* \Preset_ID - Preset ID required to match the count of players on the map
+* \ID - Id of the object to send the custom to, 0 sends to itself
+* \Message - Custom to send when when the count matches
+* \Param - Param to send when when the count matches
+* \Delay - Time to wait before sending the message
+* \Min_Player_Count - Min required players to trigger script, -1 any
+* \Max_Player_Count - Max players allowed to trigger script, -1 any
+* \Rate - Rate to scan for count changes (0.1 - 10 times a second by default).
+* \Repeat - Can the script fire more than once.
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_Player_Count_Matches_Preset_Count : public ScriptImpClass {
+	int presetId;
+	int id;
+	int custom;
+	int param;
+	float delay;
+	float rate;
+	int minPlayers;
+	int maxPlayers;
+	bool repeat;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+
+/*!
+* \brief Moves an object when a custom is received, works on zones
+* \Custom - Custom to trigger on
+* \Position - Spot to place object
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Set_Position : public ScriptImpClass {
+	int custom;
+	Vector3 position;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom after a delay, if the custom being watched for is received again the delay is reset before attempting to send again
+* \Custom - Custom to watch for
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to wait before sending
+* \RandomDelay - Random amount of delay that can be added to the delay time
+* \CancelCustom - If this custom is caught the pending custom will be canceled 
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Delay_Send_Custom : public ScriptImpClass {
+	int watchMessage;
+	int id;
+	int Param;
+	ReferencerClass lastSender;
+	int sendMessage;
+	int lastParam;
+	float delay;
+	float randomDelay;
+	int cancelCustom;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Scales the HP and armor of the object as players join/leave the match (if no players are in game the HP/Armor is not updated from the last player count)
+* \Health_Multiplier - Amount to multiply the health by per player (keep in mind the max value transmitted across the network is 10k).
+* \Armor_Multiplier - Amount to multiply the armor by per player (keep in mind the max value transmitted across the network is 10k).
+* \Max_Player_Count - Max player count allows you to specify a maximum amount of players the script should account for, any above it will be ignored.
+* \Repeat - Should the script check multiple times for player count changes 1 - yes, 0 - no.
+* \UpdateScaleCustom - If recieved the health will be updated
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Scale_HP_By_Player_Count : public ScriptImpClass {
+	int lastPlayerCount;
+	int maxPlayerCount;
+	float originalHealth;
+	float originalArmor;
+	float healthMultiplier;
+	float armorMultiplier;
+	int updateScaleCustom;
+	bool repeat;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void RescaleHP(GameObject *obj);
+};
+
+/*!
+* \brief Sends a to all objects on the map
+* \Custom - Custom to watch for
+* \Team - Required team to send to, 2 for any
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to add
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_To_All_Objects : public ScriptImpClass {
+	int recieveMessage;
+	int team;
+	int custom;
+	int Param;
+	float delay;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Prevents JMG_Utility_Enemy_Seen_Send_Custom from seening the attached object
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Enemy_Seen_Send_Custom_Ignore : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Sends a custom when an enemy is in the line of sight, sends a custom again after no enemy in the criteria is visible
+* \Enemy_Preset_ID - Preset ID required to be seen to remove the script, if 0 any enemy will trigger the script
+* \ID - Id of the object to send the custom to, 0 sends to itself, -1 sends to the seen object
+* \Visible_Message - Custom to send when there is a target that is visible
+* \Visible_Param - Param to send when there is a target that is visible
+* \Not_Visible_Message - Custom sent when no preset is visible anymore
+* \Not_Visible_Param - Param sent when no preset is visible anymore
+* \Scan_Rate - This is how often to scan for enemies
+* \Enemy_Only - Only detect enemies
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_In_Line_Of_Sight_Send_Custom : public ScriptImpClass {
+	int lastEnemyId;
+	int enemyPresetId;
+	int id;
+	int visibleMessage;
+	int notVisibleMessage;
+	int visibleParam;
+	int notVisibleParam;
+	bool enemyOnly;
+	float rate;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	bool Test_Line_Of_Sight(GameObject *obj,GameObject *seen);
+};
+
+/*!
+* \brief Prevents JMG_Utility_In_Line_Of_Sight_Send_Custom from seening the attached object
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_In_Line_Of_Sight_Send_Custom_Ignore : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Forces the attached object to scan for enemies more often (server's default rate has a random of 0.5-1.0 seconds added to the last scan)
+* \Scan_Rate - This is how often to scan for enemies
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Timer_Trigger_Enemy_Seen : public ScriptImpClass {
+	float rate;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+/*!
+* \brief Teleports the object that enters the zone to a random wander point
+* \Custom - Custom to trigger the teleport
+* \WanderingAIGroupID - Group of points to teleport to
+* \SafeTeleportDistance - How far can infantry be moved if the spot is blocked
+* \RetryOnFailure - If this is true a script will be attached that will continue to try to teleport the player until successful (Warning: Turning this on hides error messages)
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Teleport_To_Random_Wander_Point : public ScriptImpClass {
+	bool retryOnFailure;
+	int custom;
+	float safeTeleportDistance;
+	int wanderPointGroup;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	bool Get_A_Defense_Point(Vector3 *position,float *facing);
+	bool Grab_Teleport_Spot(GameObject *enter,int attempts);
+};
+
+/*!
+* \brief Sends a custom if the unit doesn't manage to move more than the specified distance in the specified time
+* \Time - amount of time the unit has to move
+* \Distance - the distance the unit has to move
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to add
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Send_Custom_If_Not_Moving_Enough : public ScriptImpClass {
+	int time;
+	int resetTime;
+	float distance;
+	int id;
+	int custom;
+	int Param;
+	float delay;
+	Vector3 lastPos;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+};
+
+
+/*!
+* \brief The AI attached to this script will flee enemies seen and combat (Like in Deer Hunter mode for ECW)
+* \MinHerdID - Min Herd ID that this object will belong to (max of 128)
+* \MaxHerdID - Max Herd ID that this object will belong to (max of 128)
+* \WanderGroupID - The wander group network the herd will use to run from threats
+* \WanderRadiusAroundHerdCenter - How far can the objects wander around the center of the herd
+* \MinWanderFrequency - Min amount of time a member of the herd can hold still before moving
+* \MaxWanderFrequency - Max amount of time a member of the herd can hold still before moving
+* \MinRetreatTime - Min amount of time that the AI can flee
+* \MaxRetreatTime - Max amount of time that the AI can flee
+* \MinUpdateHerdCenter - Min amount of time required for the center point of the herd to reposition
+* \MaxUpdateHerdCenter - Max amount of time required for the center point of the herd to reposition
+* \RunTowardThreatChance - Chance that it'll flee on purpose toward the threat (0.0 - 1.0)
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_AI_Skittish_Herd_Animal : public ScriptImpClass {
+public:
+	class HerdAnimalPositionSystem
+	{
+	public:
+		int animalCount;
+		struct HerdPositionNode
+		{
+			int id;
+			Vector3 pos;
+			bool alive;
+			struct HerdPositionNode *next;
+			HerdPositionNode(GameObject *obj)
+			{
+				this->id = Commands->Get_ID(obj);
+				this->pos = Commands->Get_Position(obj);
+				this->alive = true;
+				next = NULL;
+			}
+		};
+		Vector3 herdRetreatLocation;
+		float herdRetreatTime;
+		time_t herdRetreatStart;
+	private:
+		Vector3 centerPos;
+		time_t lastPosCalcTime;
+		float minUpdateDelay;
+		bool hascalculatedPos;
+		HerdPositionNode *HerdPositionNodeList;
+	public:
+		HerdAnimalPositionSystem()
+		{
+			herdRetreatLocation = Vector3(0.0f,0.0f,0.0f);
+			herdRetreatTime = 0.0f;
+			herdRetreatStart = clock();
+			minUpdateDelay = 10000.0f;
+			hascalculatedPos = false;
+			animalCount = 0;
+			centerPos = Vector3(0.0f,0.0f,0.0f);
+			lastPosCalcTime = clock();
+			HerdPositionNodeList = NULL;
+		}
+		HerdPositionNode *AddNode(GameObject *obj)
+		{
+			int id = Commands->Get_ID(obj);
+			HerdPositionNode *Current = HerdPositionNodeList;
+			while (Current)
+			{
+				if (Current->id == id)
+				{
+					animalCount--;
+					return Current;
+				}
+				Current = Current->next;
+			}
+			animalCount++;
+			if (!HerdPositionNodeList)
+				return (HerdPositionNodeList = new HerdPositionNode(obj));
+			Current = HerdPositionNodeList;
+			while (Current)
+			{
+				if (!Current->alive)
+				{
+					Current->id = Commands->Get_ID(obj);
+					Current->pos = Commands->Get_Position(obj);
+					Current->alive = true;
+					return Current;
+				}
+				if (!Current->next)
+				{
+					Current->next = new HerdPositionNode(obj);
+					return Current->next;
+				}
+				Current = Current->next;
+			}
+			return NULL;
+		}
+		HerdAnimalPositionSystem &operator -= (GameObject *obj)
+		{
+			int id = Commands->Get_ID(obj);
+			HerdPositionNode *Current = HerdPositionNodeList;
+			while (Current)
+			{
+				if (Current->id == id)
+				{
+					animalCount--;
+					Current->alive = false;
+					break;
+				}
+				Current = Current->next;
+			}
+			return *this;
+		}
+		Vector3 getCenterLocation(bool allowWander,int wanderPointGroup,float minUpdateHerdCenter,float maxUpdateHerdCenter);
+		bool checkRetreatSuccessful()
+		{
+			HerdPositionNode *Current = HerdPositionNodeList;
+			int retreatedCount = 0;
+			while (Current)
+			{
+				if (Current->alive && JmgUtility::SimpleDistance(Current->pos,herdRetreatLocation) < 2500)
+					retreatedCount++;
+				Current = Current->next;			
+			}
+			if (animalCount == retreatedCount)
+				return true;
+			return false;
+		}
+		bool checkRetreatCloseEnough()
+		{
+			HerdPositionNode *Current = HerdPositionNodeList;
+			int retreatedCount = 0;
+			while (Current)
+			{
+				if (Current->alive && JmgUtility::SimpleDistance(Current->pos,herdRetreatLocation) < 2500)
+					retreatedCount++;
+				Current = Current->next;			
+			}
+			if (animalCount*0.75 <= retreatedCount)
+				return true;
+			return false;
+		}
+		void Empty_List()
+		{
+			HerdPositionNode *temp = HerdPositionNodeList,*die;
+			while (temp)
+			{
+				die = temp;
+				temp = temp->next;
+				delete die;
+			}
+			HerdPositionNodeList = NULL;
+		}
+	};
+	static HerdAnimalPositionSystem HerdAnimalPositionControl[128];
+private:
+	int herdId;
+	HerdAnimalPositionSystem::HerdPositionNode *HerdPositionNode;
+	int wanderPointGroup;
+	char defaultWeapon[128];
+	float weaponRange;
+	float minRetreatRange;
+	float maxRetreatRange;
+	float minRetreatTime;
+	float maxRetreatTime;
+	float minUpdateHerdCenter;
+	float maxUpdateHerdCenter;
+	float wanderRadiusAroundHerdCenter;
+	float wanderRadiusAroundHerdCenterSq;
+	float minWanderFrequency;
+	float maxWanderFrequency;
+	float runTowardThreatChance;
+	void Created(GameObject *obj);
+	void Enemy_Seen(GameObject *obj,GameObject *seen);
+	void Timer_Expired(GameObject *obj,int number);
+	void Damaged(GameObject *obj,GameObject *damager,float damage);
+	void Destroyed(GameObject *obj);
+	void GotoLocation(GameObject *obj,const Vector3 &pos,GameObject *Enemy,float speed = 0);
+	void setRetreatLocation(GameObject *obj,GameObject *enemy);
+public:
+	JMG_Utility_AI_Skittish_Herd_Animal()
+	{
+		herdId = 0;
+		HerdPositionNode = NULL;
+	}
+	static bool Get_A_Wander_Point(Vector3 *position,int wanderPointGroup);
+};
+/*!
+* \brief Prevents JMG_Utility_AI_Skittish_Herd_Animal from seening the attached object
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_AI_Skittish_Herd_Animal_Ignore : public ScriptImpClass {
+	void Created(GameObject *obj);
+};
+
+/*!
+* \brief Just used to clean up JMG_Utility_AI_Skittish_Herd_Animal at game end, not required but nice to have
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_AI_Skittish_Herd_Animal_Controller : public ScriptImpClass {
+public:
+	JMG_Utility_AI_Skittish_Herd_Animal_Controller()
+	{
+		for (int x = 0;x < 128;x++)
+			JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionControl[x] = JMG_Utility_AI_Skittish_Herd_Animal::HerdAnimalPositionSystem();
+	}
+	void Destroyed(GameObject *obj);
+};
+
+/*!
+* \brief Displays a popup dialog to the attached player object
+* \Custom - Custom to trigger the teleport
+* \Message - Text message to display
+* \Delim - Character to use to replace with ,'s
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Display_Dialog_Box : public ScriptImpClass {
+	int custom;
+	char *textMessage;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom if the specified preset ID is on the map
+* \Custom - Custom to watch for
+* \PresetID - Preset ID to check for
+* \MinCount - Min number of presets that must exist
+* \MaxCount - Max number of presets that can exist (-1 no limit)
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to add
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_On_Preset_Count : public ScriptImpClass {
+	int recieveMessage;
+	int presetId;
+	int minCount;
+	int maxCount;
+	int id;
+	int custom;
+	int Param;
+	float delay;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+/*!
+* \brief Sends a custom if the specified script is on a preset on the map
+* \Custom - Custom to watch for
+* \Script - Script to check for
+* \MinCount - Min number of presets that must exist
+* \MaxCount - Max number of presets that can exist (-1 no limit)
+* \ID - ID to send to, 0 sends to self, -1 sends to sender
+* \SendCustom - custom to send
+* \Param - param to send (-1 sends the param that was received)
+* \Delay - delay to add
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Send_Custom_On_Script_Count : public ScriptImpClass {
+	int recieveMessage;
+	char script[128];
+	int minCount;
+	int maxCount;
+	int id;
+	int custom;
+	int Param;
+	float delay;
+	void Created(GameObject *obj);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+};
+
+
+/*!
+* \brief Sends a custom message on poke, also enables the pokable indicator icon, just like JMG_Utility_Poke_Send_Custom but sends from the poker
+* \ID - ID to send the custom to, 0 sends to self, -1 sends to poker
+* \Custom - Custom message to send
+* \Param - Param to send
+* \Delay - Delay to add before sending custom
+* \TriggerOnce - Allows the script only to trigger the first time all customs are received
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Poke_Send_Custom_From_Poker : public ScriptImpClass {
+	void Created(GameObject *obj);
+	void Poked(GameObject *obj, GameObject *poker);
+};
+
+/*!
+* \brief Scales the given score as players join/leave the match (if no players are in game the score is not updated from the last player count)
+* \GrantCustom - Custom to trigger granting the score
+* \Score - Score to give on custom
+* \ScoreMultiplier - Amount to multiply the score by per player 
+* \EntireTeam - Give the score to the whole team 0 no 1 yes
+* \MaxPlayerCount - Max player count allows you to specify a maximum amount of players the script should account for, any above it will be ignored.
+* \Repeat - Should the script check multiple times for player count changes 1 - yes, 0 - no.
+* \GrantToSender - The object to grant to, 0 is itself 1 is the sender
+* \UpdateScaleCustom - If recieved the health will be updated
+* \StopUpdateCustom - Custom to stop updating the score value
+* \author jgray
+* \ingroup JmgUtility
+*/
+class JMG_Utility_Custom_Grant_Scaled_Score : public ScriptImpClass {
+	int lastPlayerCount;
+	int maxPlayerCount;
+	int grantCustom;
+	float score;
+	float scoreMultiplier;
+	int updateScaleCustom;
+	bool repeat;
+	bool grantToSender;
+	float theScore;
+	bool entireTeam;
+	int stopUpdateCustom;
+	void Created(GameObject *obj);
+	void Timer_Expired(GameObject *obj,int number);
+	void Custom(GameObject *obj,int message,int param,GameObject *sender);
+	void RescaleScore(GameObject *obj);
+};
\ No newline at end of file
diff -uwrN sourceold/scripts/weaponmgr.h source/scripts/weaponmgr.h
--- sourceold/scripts/weaponmgr.h	2016-12-10 07:57:58.701001000 +1000
+++ source/scripts/weaponmgr.h	2018-11-11 08:30:08.538600000 +1000
@@ -96,7 +96,9 @@
 	safe_float		TargetingRange;//new
 	int             C4Preset;
 	bool			DisableHitscan;
-	bool			TrackingIgnoreTarget;
+	bool			TrackingIgnoreVehicle;
+	bool			TrackingIgnoreSoldier;
+	bool			TrackingIgnoreVTOL;
 
 #if (PARAM_EDITING_ON) || (DDBEDIT) || (W3DVIEWER)
     Vector3 ProjectileExtent;
